## ros-noetic-ur-robot-driver 2.1.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(ur_robot_driver)

add_definitions( -DROS_BUILD )

if(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
  message("${PROJECT_NAME}: You did not request a specific build type: selecting 'RelWithDebInfo'.")
  set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

find_package(catkin REQUIRED
  COMPONENTS
    actionlib
    control_msgs
    controller_manager
    controller_manager_msgs
    geometry_msgs
    hardware_interface
    industrial_robot_status_interface
    pluginlib
    roscpp
    scaled_joint_trajectory_controller
    sensor_msgs
    speed_scaling_interface
    speed_scaling_state_controller
    std_srvs
    tf
    tf2_geometry_msgs
    tf2_msgs
    trajectory_msgs
    ur_dashboard_msgs
    ur_msgs
    pass_through_controllers
    kdl_parser
)
find_package(Boost REQUIRED)
find_package(ur_client_library REQUIRED)

catkin_package(
  INCLUDE_DIRS
    include
  LIBRARIES
    ur_robot_driver_plugin
    urcl_log_handler
  CATKIN_DEPENDS
    actionlib
    control_msgs
    controller_manager
    controller_manager_msgs
    geometry_msgs
    hardware_interface
    kdl_parser
    pass_through_controllers
    pluginlib
    roscpp
    scaled_joint_trajectory_controller
    sensor_msgs
    speed_scaling_interface
    speed_scaling_state_controller
    std_srvs
    tf
    tf2_geometry_msgs
    tf2_msgs
    trajectory_msgs
    ur_dashboard_msgs
    ur_msgs
  DEPENDS
    Boost
    ur_client_library
)

add_compile_options(-Wall)
add_compile_options(-Wextra)
add_compile_options(-Wno-unused-parameter)


include_directories(
  include
  ${catkin_INCLUDE_DIRS}
  ${Boost_INCLUDE_DIRS}
)

add_library(ur_robot_driver_plugin
  src/dashboard_client_ros.cpp
  src/hardware_interface.cpp
)
target_link_libraries(ur_robot_driver_plugin ur_client_library::urcl ${catkin_LIBRARIES})
add_dependencies(ur_robot_driver_plugin ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})

add_library(urcl_log_handler
  src/urcl_log_handler.cpp
)
target_link_libraries(urcl_log_handler ${catkin_LIBRARIES} ur_client_library::urcl)

add_executable(ur_robot_driver_node
  src/dashboard_client_ros.cpp
  src/hardware_interface.cpp
  src/hardware_interface_node.cpp
)
target_link_libraries(ur_robot_driver_node ${catkin_LIBRARIES} ur_client_library::urcl urcl_log_handler)
add_dependencies(ur_robot_driver_node ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})

add_executable(dashboard_client
  src/dashboard_client_ros.cpp
  src/dashboard_client_node.cpp
)
target_link_libraries(dashboard_client ${catkin_LIBRARIES} ur_client_library::urcl urcl_log_handler)
add_dependencies(dashboard_client ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})

add_executable(robot_state_helper
  src/robot_state_helper.cpp
  src/robot_state_helper_node.cpp
)
target_link_libraries(robot_state_helper ${catkin_LIBRARIES} ur_client_library::urcl)
add_dependencies(robot_state_helper ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})


add_executable(controller_stopper_node
  src/controller_stopper.cpp
  src/controller_stopper_node.cpp
)
add_dependencies(controller_stopper_node ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(controller_stopper_node
  ${catkin_LIBRARIES}
)

if(CATKIN_ENABLE_TESTING)
  find_package(rostest REQUIRED)

  add_rostest(test/driver.test)
endif()


install(TARGETS ur_robot_driver_plugin urcl_log_handler ur_robot_driver_node robot_state_helper dashboard_client controller_stopper_node
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

catkin_install_python(PROGRAMS scripts/tool_communication scripts/test_move
  DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

install(DIRECTORY config launch resources
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})


install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
)

install(FILES hardware_interface_plugin.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

=== debian/changelog ===
ros-noetic-ur-robot-driver (2.1.2-1buster) buster; urgency=high



 -- Felix Exner <exner@fzi.de>  Sun, 22 Jan 2023 23:00:00 -0000

ros-noetic-ur-robot-driver (2.1.1-1buster) buster; urgency=high

  * Move controller_stopper to ur_robot_driver
    Since a standalone package with that name was declined during the release
    process, we decided to move the controller_stopper package over to the driver.
  * Update minimal required polyscope version in docs
  * Contributors: Felix Exner

 -- Felix Exner <exner@fzi.de>  Sun, 22 Jan 2023 23:00:00 -0000

ros-noetic-ur-robot-driver (2.1.0-1buster) buster; urgency=high

  * delete ros_control.urscript (#593 <https://github.com/UniversalRobots/Universal_Robots_ROS_Driver/issues/593>)
    We've been using the script from the library for a while now
  * Use the RobotMode message inside the SetMode action (#381 <https://github.com/UniversalRobots/Universal_Robots_ROS_Driver/issues/381>)
    This way we can make use of the predefined constants inside the RobotMode message.
  * Make several members of hw_interface atomic, for thread safety (#448 <https://github.com/UniversalRobots/Universal_Robots_ROS_Driver/issues/448>)
    Co-authored-by: Felix Exner (fexner) <mailto:exner@fzi.de>
  * Updated transformForceTorque to handle wheter it is a cb3 or an e-Series robot (#566 <https://github.com/UniversalRobots/Universal_Robots_ROS_Driver/issues/566>)
    The force torque is returned at the tool flange on e-series robots and at the tcp for CB3, this is now handled correctly, so that all force/torque measurements will be relative to the active TCP
  * Updated set payload, zero ftsensor and set tool voltage to use the ur… (#567 <https://github.com/UniversalRobots/Universal_Robots_ROS_Driver/issues/567>)
    * Updated set payload, zero ftsensor and set tool voltage to use the urdriver
    This makes it possible to call the commands when the robot is in local control if the external control script is running on the robot.
    * Update ROS interface docs
    * Fix argument passing in include instruction
    Co-authored-by: Miguel Prada <mailto:miguel.prada@tecnalia.com>
  * Remove URCap installation files from driver and replace references (#580 <https://github.com/UniversalRobots/Universal_Robots_ROS_Driver/issues/580>)
    Link to the respective Github release pages instead.
  * Drop old C++ compiler flags (#577 <https://github.com/UniversalRobots/Universal_Robots_ROS_Driver/issues/577>)
    Co-authored-by: Jochen Sprickerhof <mailto:git@jochen.sprickerhof.de>
  * Fix MoveIt! command in Example (#575 <https://github.com/UniversalRobots/Universal_Robots_ROS_Driver/issues/575>)
  * Allow empty stopped_controllers argument. (#572 <https://github.com/UniversalRobots/Universal_Robots_ROS_Driver/issues/572>)
  * Dashboard service to query whether the robot is in remote control (#561 <https://github.com/UniversalRobots/Universal_Robots_ROS_Driver/issues/561>)
    * new dashboard msg to check remote control
  * test_move: Load controller only if it is not already loaded (#552 <https://github.com/UniversalRobots/Universal_Robots_ROS_Driver/issues/552>)
  * Add optional topic rename for speed scaling factor (#544 <https://github.com/UniversalRobots/Universal_Robots_ROS_Driver/issues/544>)
    * Add optional topic rename for speed scaling factor
    * Update ROS_INTERFACE.md
  * Wait for controller action server in test_move. (#535 <https://github.com/UniversalRobots/Universal_Robots_ROS_Driver/issues/535>)
  * Minor update to display robot_ip parameter without _ (#521 <https://github.com/UniversalRobots/Universal_Robots_ROS_Driver/issues/521>)
  * Make hw_interface-node required-argument optional (#450 <https://github.com/UniversalRobots/Universal_Robots_ROS_Driver/issues/450>)
    The UR-robot is only one part of our roslaunch-setup, so I would like to be able to have the rest of the system (non-UR) continue to run even if the ur_hardware_interface-node dies.
  * Fix test move python3 (#492 <https://github.com/UniversalRobots/Universal_Robots_ROS_Driver/issues/492>)
    * make test_move work with python2 and python3
    As suggested in http://wiki.ros.org/UsingPython3/SourceCodeChanges#Changing_shebangs
    - Use a version-independent shebang
    - Use catkin_install_python to install the test_move script
  * Update feature list (#490 <https://github.com/UniversalRobots/Universal_Robots_ROS_Driver/issues/490>)
    Some minor formatting and reducing the wrench features to one features to make it more clear.
  * Contributors: Adam Heins, AndyZe, Felix Exner, Felix Exner (fexner), Johnson, Mads Holm Peters, Michael Görner, Mingu Kwon, steinmn, teapfw, williamnavaraj

 -- Felix Exner <exner@fzi.de>  Wed, 07 Dec 2022 23:00:00 -0000

ros-noetic-ur-robot-driver (2.0.0-1buster) buster; urgency=high

  * Merge pull request #408 <https://github.com/UniversalRobots/Universal_Robots_ROS_Driver/issues/408> from UniversalRobots/staging
    Adds new features to the driver:
    - Cartesian position-based control
    - Cartesian twist-based control
    - Trajectory forwarding for execution on robot
    - More documentation and examples
  * Merge branch 'master' into staging
  * Merge pull request #437 <https://github.com/UniversalRobots/Universal_Robots_ROS_Driver/issues/437> from UniversalRobots/test_move
    Add test_move script
  * Move test_move files into one
  * Added a full guide for starting with the driver
  * Add more documentation to new features (#423 <https://github.com/UniversalRobots/Universal_Robots_ROS_Driver/issues/423>)
    * Added a description for all controllers
    * Link repositories of URCap repos in feature list
    * Added note about blending with pass_through_controllers
    * Apply suggestions from code review
    Thanks @stefanscherzinger
    Co-authored-by: Stefan Scherzinger <mailto:scherzin@fzi.de>
    Co-authored-by: Stefan Scherzinger <mailto:scherzin@fzi.de>
  * Add missing license header to tool_communication
  * Added Cartesian test_move script


=== debian/control ===
Source: ros-noetic-ur-robot-driver
Section: misc
Priority: optional
Maintainer: Felix Exner <exner@fzi.de>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, ros-noetic-actionlib, ros-noetic-catkin, ros-noetic-control-msgs, ros-noetic-controller-manager, ros-noetic-controller-manager-msgs, ros-noetic-geometry-msgs, ros-noetic-hardware-interface, ros-noetic-industrial-robot-status-interface, ros-noetic-kdl-parser, ros-noetic-pass-through-controllers, ros-noetic-pluginlib, ros-noetic-roscpp, ros-noetic-rostest <!nocheck>, ros-noetic-scaled-joint-trajectory-controller, ros-noetic-sensor-msgs, ros-noetic-speed-scaling-interface, ros-noetic-speed-scaling-state-controller, ros-noetic-std-srvs, ros-noetic-tf, ros-noetic-tf2-geometry-msgs, ros-noetic-tf2-msgs, ros-noetic-trajectory-msgs, ros-noetic-ur-client-library, ros-noetic-ur-dashboard-msgs, ros-noetic-ur-msgs
Homepage: http://wiki.ros.org/ur_robot_driver
Standards-Version: 3.9.2

Package: ros-noetic-ur-robot-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-actionlib, ros-noetic-cartesian-trajectory-controller, ros-noetic-control-msgs, ros-noetic-controller-manager, ros-noetic-controller-manager-msgs, ros-noetic-force-torque-sensor-controller, ros-noetic-geometry-msgs, ros-noetic-hardware-interface, ros-noetic-industrial-robot-status-controller, ros-noetic-joint-state-controller, ros-noetic-joint-trajectory-controller, ros-noetic-kdl-parser, ros-noetic-pass-through-controllers, ros-noetic-pluginlib, ros-noetic-robot-state-publisher, ros-noetic-roscpp, ros-noetic-scaled-joint-trajectory-controller, ros-noetic-sensor-msgs, ros-noetic-speed-scaling-interface, ros-noetic-speed-scaling-state-controller, ros-noetic-std-srvs, ros-noetic-tf, ros-noetic-tf2-geometry-msgs, ros-noetic-tf2-msgs, ros-noetic-trajectory-msgs, ros-noetic-twist-controller, ros-noetic-ur-client-library, ros-noetic-ur-dashboard-msgs, ros-noetic-ur-description, ros-noetic-ur-msgs, ros-noetic-velocity-controllers, socat
Description: The new driver for Universal Robots UR3, UR5 and UR10 robots with CB3 controllers and the e-series.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-ur-robot-driver//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
